
from vsg import rule
from vsg import fix

import re


class rule_002(rule.rule):
    '''
    Function rule 002 checks there is a single space between the function keyword and the function name.
    '''

    def __init__(self):
        rule.rule.__init__(self)
        self.name = 'function'
        self.identifier = '002'
        self.solution = 'Ensure a single space exists between the "function" keyword and the function name.'
        self.phase = 2

    def analyze(self, oFile):
        fInsideFunction = False
        for iLineNumber, oLine in enumerate(oFile.lines):
            if oLine.isFunctionKeyword:
                if not re.match('^\s*function\s\w', oLine.lineLower) and not re.match('^\s*impure\s+function\s\w', oLine.lineLower):
                    self.add_violation(iLineNumber)

    def _fix_violations(self, oFile):
        for iLineNumber in self.violations:
            fix.enforce_one_space_after_word(self, oFile.lines[iLineNumber], 'function')
